/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* The Lobby provides the menu
 * a player sees when the game 
 * starts. It is the hub to most 
 * other 'RunMode's. */

#ifndef __LOBBY_H__
#define __LOBBY_H__

#include "../shared/RunMode.hpp"
#include "../shared/gui/allegro/GraphicSet.hpp"
#include "../shared/gui/allegro/BasicUserInterface.hpp"
#include "../shared/gui/menu/Menu.hpp"
#include "../shared/gui/menu/allegro/UI_Menu.hpp"

/**
 * There are includes defined at the bottom
 * of the file. Did it like that since these
 * Menus need the Lobby to be defined. */

class Lobby : public RunMode{
private:
    UI_Menu* ui_menu;

    /** There will be different menus
     * to be run within the lobby. */
    Menu* menu;
	
    RUNMODE nextrunmode;
	
    GraphicSet* graphicset;
	
    BasicUserInterface* basicuserinterface;

    INPUTTYPE currinput;
	
public:
    /** will start a Lobby with a UI_Menu
     * and a MainMenu */
    Lobby(GraphicSet* gs, BasicUserInterface* bui);

    /// deletes Lobby, UI_Menu and menu
    ~Lobby();
	
    RUNMODE run();

    void setNextRunMode(RUNMODE nrm);

    void setGraphicSet(std::string gs);

    /// deletes menu and creates a new one
    void changeMenu(MENUTYPE menutype);
};

#include "gui/MainMenu.hpp"
#include "gui/ConfigMenu.hpp"
#include "gui/QuitMenu.hpp"

#endif /* __LOBBY_H__ */
