/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "QuitMenu.hpp"

QuitMenu::QuitMenu(UI_Menu* uim, Lobby* lby){
    display = uim;
    ui = uim;
    lobby = lby;
    item.push_back(new MenuItem("Quit?", HEADLINE));
    item.push_back(new MenuItem("Do you Really want to quit?", DISABLED));
    item.push_back(new MenuItem("Yes", SELECTED));
    item.push_back(new MenuItem("No", ENABLED));
    selectItem(2);
}

QuitMenu::~QuitMenu(){
    item.clear();
}

void QuitMenu::runItem(unsigned int itemno){
    switch (itemno){
    case 2:
        lobby->setNextRunMode(QUIT);
        break;
    case 3:
        lobby->changeMenu(MAINMENU);
        break;
    default:
        break;
    }
}

