/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "Server.hpp"

Server::Server(std::string level, FSHandler* ofsh){
    fsh = ofsh;
    /* Initializing a MapLoader will trigger loading a
     * map. This might end in a failure, so let us just
     * try it. */
    try{
        ml = new MapLoader(level, fsh);
    }
    catch(Hexception& e){
        std::cerr << e.what();
    }
    map.push_back(ml->loadedMap());
    units.push_back(ml->loadedUnits());
    delete ml;
    ml = NULL;
}

void Server::doMovement(){
    units[0]->doMovement();
}

Map* Server::getMap(PLAYER plyr){
    return map[0];
}

UnitContainer* Server::getUnits(PLAYER plyr){
    return units[0];
}

void Server::updateUnits(UnitContainer* orig, PLAYER plyr){
    units[0]->sync(orig, plyr);
}
