/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "IE.hpp"

IE::IE(){
    ;
}

IE::IE(UI *oui){
    ui = oui;
}

IE::~IE(){
    for (unsigned int i=0; i<child.size(); i++){
        delete child[i];
    }
}

void IE::addChild(IE* cld){
    child.push_back(cld);
}

void IE::delChild(IE* cld){
    for( unsigned int i = 0; i< child.size(); i++){
        if( child[i] == cld){
            child.erase(child.begin()+i);
            i--;
        }
    }
}

void IE::addMsg(IE* mesg){
    msg.push_back(mesg);
}

void IE::printMsg(int msid){
    if(msid >= 0){
        child0 = child[0];
        child[0] = msg[msid];
    }else{
        child[0] = child0;
    }
}

void IE::print(){
    ui->print();
}

void IE::move(Coordinates dp){
    ui->changePos(dp);
}

INPUTTYPE IE::getInput(INPUTTYPE parinput){
    currinput = NOINPUT;
    /* first probe if any input is done via
     * child IEs (will be displayed on top
     * of this IE)
     */
    for(unsigned int i=0; (currinput == NOINPUT) && (i < child.size() ); i++){
                currinput = (child[i])->getInput(parinput);
    }
    if(currinput != NOINPUT){
        lastinput = currinput;
        return currinput;
    }
    specificInput(parinput);

    lastinput = currinput;
    return currinput;
}
