/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <allegro.h>

#include "UI_Engine.hpp"
#include "../../../definitions/Coordinates.hpp"
#include "../../allegro/BasicUserInterface.hpp"
#include "../../allegro/GraphicSet.hpp"

int main(){
    BasicUserInterface* bui = new BasicUserInterface();
    GraphicSet* gs = new GraphicSet(std::string("modernart"));
    bui->setGraphicSet(gs);
    UI_Engine* ui_engine = new UI_Engine(bui->getSize(), Coordinates(0,0), gs, bui);
    Coordinates posi;
    while(!key[KEY_ESC] && !key[KEY_Q]){
        if (key[KEY_D])
            posi.x ++;
        if (key[KEY_A])
            posi.x --;
        if (key[KEY_W])
            posi.y --;
        if (key[KEY_S])
            posi.y ++;
        if(posi.x == SCREEN_W)
            posi.x = -34;
        if(posi.y == SCREEN_H)
            posi.y = -48;
        if(posi.x <-34 )
            posi.x = SCREEN_W;
        if(posi.y < -48)
            posi.y = SCREEN_H;
        ui_engine->drawTerrain(WATER, Coordinates(100,100));
        ui_engine->drawUnit(TERRAFORMER, PLAYER1 ,posi);
        ui_engine->print();
    }
}
