/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <vector>
#include <iostream>

#include "MapLoader.hpp"
#include "../definitions/Map.hpp"
#include "../definitions/Coordinates.hpp"
#include "../units/UnitContainer.hpp"


int main(){
    Map* testmap;

    std::vector<UnitContainer>* playerdata;

    playerdata = new std::vector<UnitContainer>;
    playerdata->resize(3);

    MapLoader* ml;
    ml = new MapLoader((char*) "maps/level0.map");
    testmap = ml->loadedMap();

    for(int x=0; x < (testmap->getSize()).x; x++){
        for(int y=0; y < (testmap->getSize()).y; y++){
            std::cout << testmap->getTerrain(Coordinates(x,y)) << " ";
        }
        std::cout << std::endl;
    }
}
