/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* The MapLoader does nothing but to load the map.
 * It will automatically fill the given PlayerData
 * on creation. To get the Map, use loadedMap(). */

#ifndef _MAPLOADER_H
#define	_MAPLOADER_H

#include <vector>
#include <fstream>
#include <exception>
#include <string>
#include <boost/filesystem.hpp>
#include <boost/filesystem/fstream.hpp>

#include "FSHandler.hpp"
#include "Exceptions.hpp"
#include "../units/UnitContainer.hpp"
#include "../definitions/Map.hpp"
#include "../units/Magician.hpp"
#include "../units/Scout.hpp"
#include "../units/TerraFormer.hpp"
#include "../units/Warrior.hpp"

namespace fs = boost::filesystem;

class MapLoader{
public:
    MapLoader(std::string,FSHandler*);
    ~MapLoader();
    Map* loadedMap();
    UnitContainer* loadedUnits();
private:
    FSHandler* fsh;
    int unit(int);
    int owner(int);
    Map* map;
    UnitContainer* player;
    void loadMap(fs::path path);
};

#endif	/* _MAPLOADER_H */
